
var url = require('url');
var querystring = require('querystring');
var fs = require('fs');
var startPath = process.cwd();

//项目自定义重写，不对外暴露
var overrideList = [];
//数据访问层，不对外暴露
var DAL = {

};
//配置信息，不对外暴露
var config = {

};
//全局配置
var GLOBAL = require(startPath + '/global.js');

process.on('uncaughtException', function(e) {
    GLOBAL.global_erro(e);
});

// fs.readdir(startPath + '/override', function (erro, files) {
//     if (erro) {
//         return;
//     }
//     files.forEach(function (item) {
//         overrideList.push(require(startPath + '/override/' + item));
//     });
// });

fs.readdir(startPath + '/dal', function(erro, files) {
    if (erro) {
        return;
    }
    files.forEach(function(item) {
        var DALName = item.substring(0, item.lastIndexOf('.'));
        DAL[DALName] = require(startPath + '/dal/' + item);
    });
});

fs.readdir(startPath + '/config', function(erro, files) {
    if (erro) {
        return;
    }
    files.forEach(function(item) {
        var configName = item.substring(0, item.lastIndexOf('.'));
        config[configName] = require(startPath + '/config/' + item);
    });
});

module.exports = function(formWorkBaseDir) {

    var app = {

    };
    //引用配置，只读
    Object.defineProperty(app, 'config', {
        value: config,
        writeable: false
    });
    //数据访问层
    Object.defineProperty(app, 'DAL', {
        value: DAL,
        writeable: false
    });


    app.bufferLength = 0;
    app.buffer = new Buffer(0);
    app.bufferList = new Array();
    //初始响应代码
    app.statusCode = 200;
    //初始响应头
    app.header = app.config.fse.header;

    Object.defineProperty(app, 'init', {
        value: function(req, res) {

            Object.defineProperty(app, 'request', {
                value: req,
                writeable: false
            });
            Object.defineProperty(app, 'response', {
                value: res,
                writeable: res
            });

            Object.defineProperty(app, 'ip', {
                value: getClientIp(req),
                writeable: false
            });

            var params = {};
            switch (app.request.method.toUpperCase()) {
                case "GET":
                    params = querystring.parse(url.parse(req.url).query);
                    Object.defineProperty(app, 'params', {
                        value: params,
                        writeable: false
                    });
                    override();
                    route();
                    break;
                default:
                    app.request.on('data', function(data) {
                        if ((app.bufferLength + data.length) > app.config.fse.limit) {
                            GLOBAL.bufferOverflow(app);
                            app.request.socket.destroy();
                            return;
                        }
                        app.bufferLength += data.length;
                        app.bufferList.push(data);
                    });
                    app.request.on('end', function() {
                        app.buffer = Buffer.concat(app.bufferList);
                        params = querystring.parse(app.buffer.toString());
                        Object.defineProperty(app, 'params', {
                            value: params,
                            writeable: false
                        });
                        override();
                        route();
                    });
                    break;
            }
        },
        writeable: false
    });
    //重新封装
    Object.defineProperty(app, 'send', {
        value: function(obj) {
            app.response.writeHead(app.statusCode, app.header);
            if (typeof (obj) == 'object') {
                obj = JSON.stringify(obj);
            }
            app.response.end(obj);
            GLOBAL.session_end(app);
        },
        writeable: false
    });
    //设置APP属性函数，只读
    Object.defineProperty(app, 'set', {
        value: function(name, value) {
            app[name] = value;
        },
        writeable: false
    });

    //获取IP
    function getClientIp(req) {
        return (req.headers['x-forwarded-for'] ||
            req.connection.remoteAddress ||
            req.socket.remoteAddress ||
            req.connection.socket.remoteAddress).replace(/[\:|f]/g, '');
    };
    //执行自定义重写
    function override() {
        overrideList.forEach(function(fun) {
            if (typeof (fun) === 'function') {
                fun(app);
            }
        });
    }
    //路由
    function route() {
        var requestPath = url.parse(app.request.url).pathname;
        var index = requestPath.lastIndexOf('.');
        if (index == -1 || (index) >= requestPath.length || index == 0) {
            app.statusCode = 404;
            app.send("Non-existent");
            return;
        }
        var filePath = requestPath.substring(0, index);
        var action = requestPath.substring(index + 1, requestPath.length);

        fs.exists(startPath + "/api" + filePath + ".js", function(exists) {
            if (exists) {
                var target = require(startPath + "/api" + filePath + ".js")[action];
                if (target && typeof (target) == 'function') {
                    GLOBAL.session_start(app, action, function() {
                        target(app, app.DAL, app.config);
                    }, target);
                    return;
                }
            }
            app.statusCode = 404;
            app.send("Non-existent");
        });
    }
    return app;
};
